var localization_strings = new Array(); // [language][key]
var localization_language = "en";

jQuery.urlParam = function(name){
    var results = new RegExp('[\?&]' + name + '=([^&#]*)').exec(window.location.href);
    if (results==null){
       return null;
    }
    else{
       return results[1] || 0;
    }
}

function TR_Init(complete) {
	
	if ( (typeof navigator != "undefined") && (typeof navigator.globalization != "undefined") ) {
	navigator.globalization.getLocaleName(function(locale) {
		locale = locale.value;
		
		if (jQuery.urlParam("language"))
			locale = jQuery.urlParam("language");
		
		console.log("TR_Init: "+locale);
		locale = locale.toLowerCase();
		if (locale.indexOf("it")>=0)
			localization_language="it";
		if (typeof complete != "undefined")
			complete();
	}, function() {
		if (typeof complete != "undefined")
			complete();
	});
	} else {
		var userLang = navigator.language || navigator.userLanguage; 
		locale = userLang;

		if (jQuery.urlParam("language"))
			locale = jQuery.urlParam("language");
		
		console.log("TR_Init: "+locale);
		locale = locale.toLowerCase();
		if (locale.indexOf("it")>=0)
			localization_language="it";		
		
		if (typeof complete != "undefined")
			complete();		
	}
}

function replaceAll(src, token, newToken, ignoreCase) {
	var _token;
	var str = src + "";
	var i = -1;

	if (typeof token === "string") {

		if (ignoreCase) {

			_token = token.toLowerCase();

			while ((i = str.toLowerCase().indexOf(token,
					i >= 0 ? i + newToken.length : 0)) !== -1) {
				str = str.substring(0, i) + newToken
						+ str.substring(i + token.length);
			}

		} else {
			return str.split(token).join(newToken);
		}
	}
	return str;
};

function TR(tag, pars) {
	if (typeof pars == undefined)
		pars = [];

	if (typeof localization_strings[localization_language] == "undefined")
		return "lng_" + localization_language + "_not_found";
	if (typeof localization_strings[localization_language][tag] == "undefined")
		return "lng_" + localization_language + "_" + tag + "_not_found";

	var msg = localization_strings[localization_language][tag];

	for (key in pars) {
		msg = replaceAll(msg, "{" + key + "}", pars[key], false);
	}

	return msg;
};
